// Copyright (C) 1999-2008
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __frame3dtruecolor_h__
#define __frame3dtruecolor_h__

#include "frame3d.h"
#include "frame3dtrue.h"

class Frame3dTrueColor : public Frame3d, public Frame3dTrue {
 private:
  double** zbuf;
  unsigned char** mkzbuf;

 protected:
  long* colormapData;

 private:
  void buildXImage(XImage*, double* (FitsImage::*getMatrix)());
  unsigned char* fillImage(int, int, double* (FitsImage::*)());
  unsigned char* fillImageBlend(int, int, int, double* (FitsImage::*)());
  unsigned char* fillImageColor(int, int);
  unsigned char* fillImageAIP(int, int, int, double* (FitsImage::*)());
  unsigned char* fillImageMIP(int, int, int, double* (FitsImage::*)());
  unsigned char* fillImageThreshold(int, int, int, double* (FitsImage::*)());

#ifdef _MACOSX
  void macosx(float, int, int, const Vector&, const Vector&);
#endif
#ifdef _WIN32
  void win32(float, int, int, const Vector&, const Vector&);
#endif

 public:
  Frame3dTrueColor(Tcl_Interp*, Tk_Canvas, Tk_Item*);
  virtual ~Frame3dTrueColor();

  void colormapCmd(int, float, float, int, 
		   unsigned short*, unsigned char*, int);
  void colormapMotionCmd(int id, float b, float c, int i, 
			 unsigned short* index, unsigned char* cells, int cnt)
  {colormapCmd(id,b,c,i,index,cells,cnt);}
};

#endif
